/* cusr>login>inc>login.h
**
** Typedefs and defines for external login program.
**
**    date     sign     comment
**    890405   flg      Initial coding
**    890414   flg      Added MyPos, MyLinTyp, MyLtyp, MyTerm (from terminfo)
**    890810   flg      Updated for Rev 22.
**    890920   flg      Added UNPRIVILIGEFILE and UNCPUPRIVILIGEFILE
**
** Copyright (c) 1989, V{sterh|jdskolan Sk|vde.
*/

#include <charvar.h>

#ifdef  AllocateGlobals
#  define global
#else
#  define global extern
#endif

#ifdef __DEBUG
#  define  dputs(s)     puts(s)
#  define  dprintf(f,s) printf(f, s)
#  define  void         char
#else
#  define  dputs(s)
#  define  dprintf(f,s)
#endif

#define MAXGRP             32
#define UNPRIVILIGEDFILE   "etc>locked.out"
#define PRIVILIGEDFILE     "etc>priviliged"
#define LOGINTEXT          "etc>login.txt"
#define NEWSFILE           "etc>newsfile"


/* GETID$ user id structure
**
*/
typedef  struct
{
   short                 version;    /* Version must be 1 or 2 in 20.2 */
   charvar(32)            Userid;
   short              GroupCount;
   charvar(32)   Groups [MAXGRP];
}
   FULL_ID;

global   short   MyTypep;
global   short   MyNr;
global   int     NrGroups;

global   char    MyName        [32];
#ifdef VHOJD
global   char    MyTerm        [32];
global   char    MyLtyp        [32];
global   char    MyPos         [32];
global   char    MyPrinter     [32];
#endif
global   char    *Group    [MAXGRP];
global   char    MyPrj         [32];

#define IsPhant(t)        (((t) >= u$lput) && ((t) <= u$hput))

