/* cusr>login>src>getusrinfo.c
**
** Retrieve user information.
**
**    date     sign     comment
**    890414   flg      initial coding.
**    890810   flg      Updated for rev 22.
**    890817   flg      Removed reference to C1 library.
**    890907   flg      Check for cpu member.
**
*/
#include <stdio.h>
#include <string.h>
#include <charvar.h>
#include "login.h"

fortran void PRJID$(), UTYPE$(), USER$(), GETID$();

GetUserInformation()
{
   char  * WhereAmI(),
          * WhatAmI();
   int              i;
   short        slask;
   charvar(32) projid;

   if ((NrGroups = getid( MyName, Group, MAXGRP )) == -1)
   {
      perror("getid");
      return 0;
   }


   UTYPE$(MyTypep);
   USER$(MyNr, slask);
   PRJID$(projid);

   getcvar(MyPrj, projid);    /* Convert from char()var to C string. */

#ifdef VHOJD
   strcpy(MyPos, WhereAmI());
   strcpy(MyLtyp, WhatAmI());

   MyPrinter[0] = '\0';

   GetTerm(MyTerm);

   if (GetPrinter(MyPrinter, MyNr) == -1)
      perror("GetPrinter");

   if (! *MyPrinter)
      strcpy(MyPrinter, MyTerm);
#endif

   return 1;
}


/* getid
** **********************************************************************
*/

int getid( userid, grouplist, maxgrp )
char * userid;
char ** grouplist;
int maxgrp;
{
   FULL_ID full_id;
   short errcode=0;
   int i;
   char tmp[100];

   full_id.version = 2;

   GETID$(&full_id, (short) maxgrp, errcode);
   if (errcode)
   {
      errno = errcode;
      return -1;
   }

   getcvar(userid, full_id.Userid);

   for(i=0;i<full_id.GroupCount;i++)
   {
      getcvar(tmp, full_id.Groups[i]);
      grouplist[i] = strdup(tmp);
   }

   return i;
}



