/* login/is.c
**
** A set of is...() function.
**
**    date     sign     comment
**    890414   flg      initial coding
**    890810   flg      Updated for new login program rev 22.
**    890830   flg      Added isCpu()
**    890908   flg      Changed logic of isadm, to support priv file on project
**                      basis
**
**
** Copyright (c) 1989, V{sterh|jdskolan Sk|vde.
*/
#include <stdio.h>
#include <string.h>

#include "login.h"

/* IsElev()
**
** Returns "true" if the current user is classified as a "elev" (swedish
** for student).
**
*/
int IsElev()
{

   int  i;

   /*
   ** Need to keep compatibility with old system..
   */
   if ( !strncmp(MyName, "E.", 2) || !strncmp(MyName, "ELEV.", 5) ||
        !strncmp(MyName, "EM.", 3) )
      return 1;

   /*
   ** Now check the groups as well.
   */
   for(i=0;i<NrGroups;i++)
      if (strcmp(Group[i],".ELEVER") == 0)
         return 1;

   return 0;
}


/*
** IsAdm()
**
** Check if user is allowed to log in.
**
** This function is used to lock out all user except the ones needed
** for service or something..
**
*/
int IsAdm()
{
   if ( xfexists(PRIVILIGEDFILE))
   {
      if(! Isinfile(PRIVILIGEDFILE))
         return 0;
   }

   return 1;
}

/*
** IsLockedOut()
**
** Check if user is being locked out.
**
**
*/
int IsLockedOut()
{
   if ( xfexists(UNPRIVILIGEDFILE))
   {
      if(Isinfile(UNPRIVILIGEDFILE))
         return 1;
   }
   return 0;
}

/*
** Isinfile()
**
** Check if this user exists in the file (either by group or by userid)
**
**
*/
Isinfile(fname)
char * fname;
{
   FILE * fp;
   char * cp, buffer[80];
   int i;

   if (! (fp=fopen(fname, "r")))
   {
      perror(fname);
      puts("Please contact system administrator");
      return 0;
   }

   while(fgets(buffer, 80, fp))
   {
      if (cp=strchr(buffer, '\n')) * cp = '\0';

      if(strcmp(buffer, MyName) == 0)
      {
         fclose(fp);
         return 1;
      }

      for(i=0;i<NrGroups;i++)
         if (strcmp(buffer, Group[i]) == 0)
         {
            fclose(fp);
            return 1;
         }
   }

   fclose(fp);

   return 0;
}

/*
**
*/

int ModemRight(elevFlag)
int elevFlag;
{
   int i;

   if (strcmp(MyLtyp, "MODEM") == 0)
   {
      for(i=0;i<NrGroups;i++)
         if (strcmp(Group[i], ".MODEM") == 0)
            return 1;

      return elevFlag ? 0 : 1;
   }
   return 1;
}


/* PhantomRight()
**
*/

PhantomRight( elevFlag )
int elevFlag;
{
   int i;

   for(i=0;i<NrGroups;i++)
      if (strcmp(Group[i], ".PHANTOM") == 0)
         return 1;

   return elevFlag ? 0 : 1;
}
