/* cusr>login>src>login.c
**
** V{sterh|jdskolans Externa login program.
**
**    Date     Programmer        History
**    --------------------------------------------------------------------
**    890404   Fredrik Lindberg  initial coding (from old ftn/spl version)
**    890810   Fredrik Lindberg  Major rewrite for Rev 22.
**    890830   Fredrik Lindberg  Changed to let Gterm inhibit breaks.
**    890920   Fredrik Lindberg  Added IsLockedOut().
**    891027   Fredrik Lindberg  Non-terminal processes should NOT call
**                               SetupEnv..
**
** Copyright (c) 1989, V{sterh|jdskolan Sk|vde.
*/

#include <stdio.h>
#include <keys>
#include <term.h>
#include <user_types.h>

fortran void LOGO$$ ();

#ifndef __DEBUG
#  define logout()  LOGO$$((short)0,(short)0,(short)0,(short)0,(short)0, error)
#else
#  define logout()  { puts("Loggin out"); exit(0); }
#endif


#define  AllocateGlobals
#include "login.h"

fortran main()
{
   int   Elev=0, Adm=0;
   short error = 0;
   struct term buf;

   gterm(&buf);
   buf.tt_flags |= XON;
   buf.tt_flags |= INHIBIT_BREAK;
   sterm(&buf);


   if (!GetUserInformation())
   {
      puts("Error! Unable to retrieve information about the user!");
      logout();
   }

   Elev =   Iselev();   /* Check if this is a student. */

   if (!IsAdm())        /* Is the system closed? */
   {
      puts("****************************************");
      puts("Sorry! The system is closed for service ");
      puts("****************************************");
      logout();
   }

   if (IsLockedOut())    /* Is this person prohibited from using the system? */
   {
      puts("*************************************");
      puts("Sorry! You have been locked out!     ");
      puts("*************************************");
      logout();
   }


   if ( IsPhant(MyTypep) && (MyTypep != u$bach)) /* If phantom and not batch */
   {
      if ( !PhantomRight(Elev) ) /* Is this student allowed to be a phantom? */
      {
         puts("**************************************************");
         puts("Sorry, you are not allowed to run as a phantom!   ");
         puts("**************************************************");
         logout();
      }
   }

   if (!ModemRight(Elev))
   {
      puts("****************************************************");
      puts("Sorry! You are not allowed to login through a modem!");
      puts("****************************************************");

      logout();
   }

   if (!IsPhant(MyTypep))      /* If interactive user, show him a welcome! */
      Entre();

   if (! IsPhant(MyTypep))
      SetupEnv ();         /* Only do this if he is an interactive user. */

   if (! fexists("LOGIN.RUN"))
   {
      gterm(&buf);
      buf.tt_flags |= ENABLE_BREAK;
      sterm(&buf);
   }

   return;
}







